//---------------------------------------------------------------------------
// JrDebug demo that demonstrates various features
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// System includes
#include <iostream>
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Include the Debugging Library files
//  Note that only our main .cpp needs to include the jrdebug_main.cpp file
//  alternatively, you could add this cpp to your project or makefile.
#include "../../jrdebug_main.cpp"
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Forward declaration
int WorkFunction();
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
int main(int argc, char *argv[])
{
	// call the work function and report it + time it
	int retv;

	// automatically parse commandline options and exit if appropriate
	if (JrDebugParseCommandlineArgc("Demo8",&argc,argv,"-db"))
		return 0;

	JrDebugEnclose(WorkFunction());
	JrDebugEnclose(retv=WorkFunction());

	// anything here is outside of scope of the "all looping" debugblock
	dbprintf("Program has finished: %d.",retv);

	// all done
	return 0;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
int WorkFunction()
{
	int count3,count4,count5;
	for (int count2=0;count2<10;++count2)
		{
		// report this loop block
		debugblock("inner loop");
		// take some time
		for (count3=0;count3<30000;++count3)
			{
			for (count4=0;count4<300;++count4)
				{
				// just eat up some cpu cycles
				count5=count3-count2; count5++; count5--; count5=count3-count2;
				}
			}
		}
	// return dummy value
	return 999;
}
//---------------------------------------------------------------------------
